%global version_major 1
%global version_minor 2
%global version_micro 8
%global meadalpha %{nil}
%global meadrel %{nil}
%global commitid JWS_3.1.0.SP2.DR2
%global serial 11

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root

%define _with_zips 1
# If you want to build the zips,
# give rpmbuild option '--with zips'

%define with_zips %{?_with_zips:1}%{!?_with_zips:0}
%define without_zips %{!?_with_zips:1}%{?_with_zips:0}

%define packdname %{name}-%{version}-src

Name:           tomcat-native
Version:        1.2.8
Release:        %{serial}.redhat_%{serial}%{?dist}
Summary:        Tomcat native library

Group:          System Environment/Libraries
License:        ASL 2.0
URL:            http://tomcat.apache.org/tomcat-6.0-doc/apr.html

Source0: %{name}-%{commitid}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?rhel}" == "7"
#64 bit only natives on RHEL 7
ExcludeArch:   i686 i386
%endif

%if "%{?rhel}" == "7"
BuildRequires:  java-devel
%else
BuildRequires:  java7-devel
%endif
BuildRequires:  jbcs-httpd24-httpd-devel, jbcs-httpd24-httpd-libs
BuildRequires:  jpackage-utils
BuildRequires:  jbcs-httpd24-openssl, jbcs-httpd24-openssl-devel, jbcs-httpd24-openssl-libs
BuildRequires:  zip

Requires:       jbcs-httpd24-httpd-libs
Requires(pre):  shadow-utils

%global __requires_exclude libapr.*
%{?filter_setup:
%filter_from_requires /libapr.*/d
%filter_setup
}

# Upstream compatibility:
Provides:       tcnative = %{version}-%{release}

%description
Tomcat can use the Apache Portable Runtime to provide superior
scalability, performance, and better integration with native server
technologies.  The Apache Portable Runtime is a highly portable library
that is at the heart of Apache HTTP Server 2.x.  APR has many uses,
including access to advanced IO functionality (such as sendfile, epoll
and OpenSSL), OS level functionality (random number generation, system
status, etc), and native process handling (shared memory, NT pipes and
Unix sockets).  This package contains the Tomcat native library which
provides support for using APR in Tomcat.

%if %{with_zips}
%package src-zip
Summary:     Container for the sources of the Tomcat native library.
Group:       Development

%description src-zip
Container for the sources of the Tomcat native library
%endif

%prep
%setup -q -n %{name}-%{commitid}

%if %{with_zips}
zip -q -r ../%{packdname}.zip *
%endif

%build
cd native
# There is a bug in the tcnative script (asfbz#59996) that always uses lib, so this works around that
test -d "%{scldir}/usr/lib64" && sed -i 's@TCN_OPENSSL_LIBS="-L$use_openssl/lib -Wl,-rpath,$use_openssl/lib -lssl -lcrypto@TCN_OPENSSL_LIBS="-L$use_openssl/lib64 -Wl,-rpath,$use_openssl/lib64 -lssl -lcrypto@g' configure

# Setting LDFLAGS equal to the global_ldflags value so that we
# append new values instead of clobber them.
%{?__global_ldflags:LDFLAGS="%__global_ldflags"}
test -d "%{scldir}/usr/lib64" && \
LDFLAGS="-L%{scldir}/usr/lib64 $LDFLAGS" || \
LDFLAGS="-L%{scldir}/usr/lib $LDFLAGS"
# Export require for rhel-6; rhel-6 handles this in the configure macro
export LDFLAGS
%configure \
    --with-apr=%{scldir}%{_bindir}/apr-1-config \
    --with-ssl=%{scldir}/usr \
    --with-java-home=%{java_home} \
    --with-java-platform=2
make %{?_smp_mflags} CFLAGS=-fno-strict-aliasing


%install
rm -rf $RPM_BUILD_ROOT
make -C native install DESTDIR=$RPM_BUILD_ROOT
# Perhaps a devel package sometime?  Not for now; no headers are installed.
rm -f $RPM_BUILD_ROOT%{_libdir}/libtcnative*.*a
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig

%ifarch i386 i686
archdir=linux-i686
%endif
%ifarch ppc64
archdir=linux-ppc64
%endif
%ifarch x86_64
archdir=linux-x86_64
%endif

%if %{with_zips}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} ../%{packdname}.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/
%endif

%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGELOG.txt LICENSE NOTICE
# Note: unversioned *.so needed here due to how Tomcat loads the lib :(
%{_libdir}/libtcnative*.so*

%if %{with_zips}
%files src-zip
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev/%{packdname}.zip
%endif

%changelog
* Mon Dec 18 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-9.redhat_9
- Resolves: JWS-865 Correctly calculate field lengths when parsing the OCSP extension so that longer values are read correctly

* Mon Feb 27 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-8.redhat_8
- Resolves: JWS-657 tomcat-native installs RHEL apr in addition to jbcs-httpd24-httpd-libs

* Thu Feb 02 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-7.redhat_7
- Resolves: JWS-616 tomcat-native uses the wrong APR library

* Fri Sep 09 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-6.redhat_6
- Adjusting BuildRequires after JBCS-150 was fixed

* Fri Jul 08 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-1.redhat_1
- Building 1.2.8 as JWS 3.1 candidate

* Wed Jun 01 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-2.redhat_1
- Update LDFLAGS setting to include %__global_ldflags value instead of ignoring the previous value
- Add export of LDFLAGS to fix rhel-6 builds

* Thu Apr 21 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-1.redhat_1
- Building 1.2.6 as JWS 3.1 candidate
